//==================================================================
// EnhancedTeamInfo
//==================================================================
class EnhancedTeamInfo extends TeamInfo;

struct sPlayerData
{
	var PlayerReplicationInfo PRI;	// Owner.
	var byte Health;		// Health (0-199)
	var class<Weapon> cWeapon;	// Weapon
	var byte AmmoLeft;		// And ammo to weapon. (0-250)
	var byte Armor, Pads, Shield;	// Has if >0
	var byte Other;
};

var sPlayerData PData[32];

replication
{
	reliable if (ROLE == ROLE_Authority)
		PData;
}

function PostBeginPlay()
{
	SetTimer(Level.TimeDilation, True);	// Update every once pr second.
}

function Timer()
{
	local Pawn P;
	local int num, ammo, armor, pads, shield;
	local PlayerReplicationInfo PRI;
	local Inventory Inv;
	local byte Other;

	for (P = Level.PawnList; P != None; P = P.NextPawn)
	{
		PRI = P.PlayerReplicationInfo;
		if (PRI == None || PRI.bIsSpectator || PRI.Team > 3)
			continue;
		PData[num].PRI = PRI;
		PData[num].Health = Clamp(P.Health, 0, 199);
		ammo = 0;
		if (P.Weapon != None)
		{
			PData[num].cWeapon = P.Weapon.Class;
			if (P.Weapon.AmmoType != None)
				ammo = P.Weapon.AmmoType.AmmoAmount;
		}
		else
			PData[num].cWeapon = None;
		PData[num].AmmoLeft = Min(250, ammo);
		armor = 0;
		pads = 0;
		shield = 0;
		Other = 0;
		for (Inv = P.Inventory; Inv != None; Inv = Inv.Inventory)
		{
			if (Inv.IsA('Armor2'))
				armor = Inv.Charge;
			else if (Inv.IsA('ThighPads'))
				pads = Inv.Charge;
			else if (Inv.IsA('UT_ShieldBelt'))
				shield = Inv.Charge;
			else if (Inv.IsA('UT_JumpBoots'))
				Other = Other | 1;
			else if (Inv.IsA('UDamage'))
				Other = Other | 2;
			else if (Inv.IsA('UT_Invisibility'))
				Other = Other | 4;
		}
		PData[num].Armor = armor;
		PData[num].Pads = pads;
		PData[num].Shield = shield;
		PData[num].Other = Other;
		num++;
		if (num == 32)
			break;
	}

	while (num < 32)
	{
		PData[num++].PRI = None;
	}
}

simulated function xxGetData(int Index, PlayerReplicationInfo AskingPRI,
					out PlayerReplicationInfo PRI, out int Health, out class<Weapon> cWeapon,
					out int Ammo, out int Armor, out int Pads, out int Shield,
					out int Other)
{
	PRI = PData[Index].PRI;
	if (PRI == None || PRI == AskingPRI || AskingPRI.Team != PData[Index].PRI.Team)
	{	// If not existing, your self, or wrong team ignore.
		PRI = None;
		return;
	}
	
	PRI = PData[Index].PRI;
	Health = PData[Index].Health;
	cWeapon = PData[Index].cWeapon;
	Ammo = PData[Index].AmmoLeft;
	Armor = PData[Index].Armor;
	Pads = PData[Index].Pads;
	Shield = PData[Index].Shield;
	Other = PData[Index].Other;
}

defaultproperties
{
}
