//====================================================================
// HUDHelper
//====================================================================
//	#exec TEXTURE IMPORT NAME=InvisIcon FILE=Textures\InvisIcon.bmp GROUP=Icons FLAGS=2
#exec TEXTURE IMPORT NAME=UdamIcon FILE=Textures\UdamIcon.bmp GROUP=Icons FLAGS=2
#exec TEXTURE IMPORT NAME=TimeBG FILE=Textures\TimeBG.bmp GROUP=Icons FLAGS=2
#exec TEXTURE IMPORT NAME=BootsBG FILE=Textures\BootsBG.bmp GROUP=Icons FLAGS=2

class HUDHelper extends Actor
	abstract;

static simulated function DrawImprovedTeamInfo(Canvas Canvas, EnhancedTeamInfo ETI, ChallengeTeamHUD HUD)
{
	local float fW, fH;
	local float fY;
	local int x, i;
	local string s;
	local PlayerReplicationInfo oPRI, pPRI;
	local int Health, Armor, Pads, Shield, Ammo, Other;
	local class<Weapon> cWeapon;
	local float LocN, LocH, LocA, LocO;

	Canvas.Font = HUD.MyFonts.GetSmallestFont( Canvas.ClipX );
	Canvas.StrLen("123456", fW, fH);

	fY = Canvas.ClipY * 0.5;

	oPRI = HUD.PlayerOwner.PlayerReplicationInfo;
/*
	if (oPRI.Team == 0)
		TeamColor = RedColor;
	else
		TeamColor = BlueColor;
*/
	// Draw like:
	// PlayerName (Location) : Weapon (Ammo)
	// Health   Armor   Other
	LocN = 5.0;
	LocH = LocN;
	LocA = LocH + fW;
	LocO = LocA + fW;

	for (x = 0; x < 32; x++)
	{
		ETI.xxGetData(x, oPRI, pPRI, Health, cWeapon, Ammo, Armor, Pads, Shield, Other);
		if (pPRI == None)
			continue;

		// PlayerName (Location):(Health%)  
		Canvas.DrawColor = HUD.WhiteColor;

		if ( pPRI.PlayerLocation != None )
			s = pPRI.PlayerLocation.LocationName;
		else if ( pPRI.PlayerZone != None )
			s = pPRI.PlayerZone.ZoneName;
		else 
			s = "";
		if (s != "")
			s = " ("$s$")";

		if (cWeapon == None)
			s = s$": No weapon";
		else
			s = s$":"@cWeapon.Default.ItemName$" ("$Ammo$")";

		Canvas.SetPos(LocN, fY);
		Canvas.DrawText(pPRI.PlayerName$s);

		fY += fH;
		
		// 199->121 = green, 120-81 = blueish, 80-41 = yellow, 40-0 = red
		if (Health > 120)
			Canvas.DrawColor = HUD.GreenColor;
		else if (Health > 80)
			Canvas.DrawColor = HUD.CyanColor;
		else if (Health > 40)
			Canvas.DrawColor = HUD.GoldColor;
		else
			Canvas.DrawColor = HUD.RedColor;
		Canvas.SetPos(LocH, fY);
		Canvas.DrawText(Health$"% ");

		i = Armor + Pads + Shield;
		if (i > 0)
		{
			if (Shield > 0)
				Canvas.DrawColor = HUD.GoldColor;
			else
				Canvas.DrawColor = HUD.WhiteColor;
			Canvas.SetPos(LocA, fY);
			Canvas.DrawText(i$"A ");
		}

		Canvas.DrawColor = HUD.WhiteColor;
		s = "";
		if ((Other & 1) != 0)
			s = s@"Boots";
		if ((Other & 2) != 0)
			s = s@"Amp";
		if ((Other & 4) != 0)
			s = s@"Invis";
		if (CTFFlag(pPRI.HasFlag) != None)
			s = s@"*** FLAGCARRIER ***";
		Canvas.SetPos(LocO, fY);
		Canvas.DrawText(s);		
		
		fY += (fH * 1.5);
		if (fY > Canvas.ClipY)
			break;		// Too many.
	}

}

static simulated function DrawTime(Canvas Canvas, float X, float Y, int Seconds)
{
	local int Min, Sec;
	local string Time;
	local float fX, fY;
	
//	Min = GRI.RemainingTime;
//	if (Min == 0)
//		Min = GRI.ElapsedTime;
	Seconds = Abs(Seconds);

	Min = Seconds / 60;
	Sec = Seconds % 60;

	Time = string(Min)$":";
	if (Sec < 10)
		Time = Time$"0"$string(Sec);
	else
		Time = Time$string(Sec);

	Canvas.StrLen(Time, fX, fY);
	Canvas.SetPos(X - fX * 0.5, Y - fY * 0.5);
	Canvas.DrawText(Time);
}

static simulated function TimeFont(Canvas Canvas, float Scale, FontInfo MyFonts)
{
	if (Scale > 0.5)
		Canvas.Font = MyFonts.GetHugeFont(Canvas.ClipX);
	else if (Scale > 0.3)
		Canvas.Font = MyFonts.GetBigFont(Canvas.ClipX);
	else if (Scale > 0.2)
		Canvas.Font = MyFonts.GetMediumFont(Canvas.ClipX);
	else if (Scale > 0.1)
		Canvas.Font = MyFonts.GetSmallFont(Canvas.ClipX);
	else
		Canvas.Font = MyFonts.GetSmallestFont(Canvas.ClipX);
}

defaultproperties
{
}
