//===================================================================
// NW_FlakCannon
//===================================================================
class NW_FlakCannon expands UT_FlakCannon;

#exec TEXTURE IMPORT NAME=Smoke2 FILE=TEXTURES\Smoke.bmp MIPS=OFF LODSET=2

// Fire chunks
function Fire( float Value )
{
	local Vector Start, X,Y,Z;
	local Bot B;
	local Pawn P;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		bCanClientFire = true;
		bPointing=True;
		Start = Owner.Location + CalcDrawOffset();
		B = Bot(Owner);
		P = Pawn(Owner);
		P.PlayRecoil(FiringSpeed);
		Owner.MakeNoise(2.0 * P.SoundDampening);
		AdjustedAim = P.AdjustAim(AltProjectileSpeed, Start, AimError, True, bWarnTarget);
		GetAxes(AdjustedAim,X,Y,Z);
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));		
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;	

		Spawn( class 'NW_UTChunk',, '', Start, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start - Z, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start + 2 * Y + Z, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start - Y, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start + 2 * Y - Z, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start - Z, AdjustedAim);
		Spawn( class 'NW_UTChunk',, '', Start + 2 * Y + Z, AdjustedAim);



		// lower skill bots fire less flak2 chunks
		if ( (B == None) || !B.bNovice || ((B.Enemy != None) && (B.Enemy.Weapon != None) && B.Enemy.Weapon.bMeleeWeapon) )
		{
			Spawn( class 'NW_UTChunk',, '', Start + Y - Z, AdjustedAim);
			Spawn( class 'NW_UTChunk',, '', Start + 2 * Y + Z, AdjustedAim);
		}
		else if ( B.Skill > 1 )
			Spawn( class 'NW_UTChunk',, '', Start + Y - Z, AdjustedAim);

		ClientFire(Value);
		GoToState('NormalFire');
	}
}

function AltFire( float Value )
{
	local Vector Start, X,Y,Z;

	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if (AmmoType.UseAmmo(1))
	{
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bPointing=True;
		bCanClientFire = true;
		Owner.MakeNoise(Pawn(Owner).SoundDampening);
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		Start = Owner.Location + CalcDrawOffset();
		Spawn(class'WeaponLight',,'',Start+X*20,rot(0,0,0));		
		Start = Start + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z; 
		AdjustedAim = pawn(owner).AdjustToss(AltProjectileSpeed, Start, AimError, True, bAltWarnTarget);	
		Spawn(class'NW_FlakSlug',,, Start,AdjustedAim);
		ClientAltFire(Value);	
		GoToState('AltFiring');
	}	
}

function SetSwitchPriority(pawn Other)
{	// Make sure "old" priorities are kept.
	local int i;
	local name temp, carried;

	if ( PlayerPawn(Other) != None )
	{
		for ( i=0; i<ArrayCount(PlayerPawn(Other).WeaponPriority); i++)
			if ( IsA(PlayerPawn(Other).WeaponPriority[i]) )		// <- The fix...
			{
				AutoSwitchPriority = i;
				return;
			}
		// else, register this weapon
		carried = 'UT_FlakCannon';
		for ( i=AutoSwitchPriority; i<ArrayCount(PlayerPawn(Other).WeaponPriority); i++ )
		{
			if ( PlayerPawn(Other).WeaponPriority[i] == '' )
			{
				PlayerPawn(Other).WeaponPriority[i] = carried;
				return;
			}
			else if ( i<ArrayCount(PlayerPawn(Other).WeaponPriority)-1 )
			{
				temp = PlayerPawn(Other).WeaponPriority[i];
				PlayerPawn(Other).WeaponPriority[i] = carried;
				carried = temp;
			}
		}
	}		
}

simulated function PlayIdleAnim()
{
	if ( Mesh != PickupViewMesh )
		PlayAnim('Still',1.0, 0.05);
}

function TweenDown()
{
	PlayAnim('Down', 100.0, 0.00);
}

function PlaySelect()
{
	PlayAnim('Select',100.0,0.0);
	Owner.PlaySound(SelectSound, SLOT_Misc, Pawn(Owner).SoundDampening);
}

simulated function Tick(float DeltaTime)
{
	if ((Region.Zone.bDestructive || Region.Zone.bKillZone || Region.Zone.DamagePerSec > 0) && Pawn(Owner) == None)
	{
		Destroy();
	}
}

defaultproperties {
    ProjectileClass=Class'NW_UTChunk'
    AltProjectileClass=Class'NW_FlakSlug'
    DeathMessage="%k spammed %o down with the %w."
	SelectSound=Sound'UnrealI.flak.Hidraul2'
}
