//===================================================================
// NW_Minigun
//===================================================================
class NW_Minigun extends minigun2;

var float FireInterval, NextFireInterval;

function Fire( float Value )
{
	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if ( AmmoType.UseAmmo(1) )
	{
		SoundVolume = 255*Pawn(Owner).SoundDampening;
		Pawn(Owner).PlayRecoil(FiringSpeed);
		bCanClientFire = true;
		bPointing=True;
		ShotAccuracy = 0.2;
		FireInterval = 0.130;		// Spinup
		NextFireInterval = 0.08;	// 12.5 shots/sec
		ClientFire(value);
		GotoState('NormalFire');
	}
	else GoToState('Idle');
}

function AltFire( float Value )
{
	if ( AmmoType == None )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if ( AmmoType.UseAmmo(1) )
	{
		bPointing=True;
		bCanClientFire = true;
		ShotAccuracy = 0.95;
		FireInterval = 0.130;		// Spinup
		NextFireInterval = 0.08;	// Use Primary fire speed until completely spun up
		Pawn(Owner).PlayRecoil(FiringSpeed);
		SoundVolume = 255*Pawn(Owner).SoundDampening;		
		ClientAltFire(value);	
		GoToState('AltFiring');		
	}
	else GoToState('Idle');	
}

/*
simulated function Tick(float deltaTime)
{	// This fixes the really annoying issue regarding minigun sound
	if (Pawn(Owner) == None || Pawn(Owner).Weapon != Self)
		AmbientSound = None;
}
*/

// Original code did: Sleep(0.13)
// This would (depending on tickrate) get called on irregular intervals.
// According to a 20 tickrate server, this would result in about 6.667 shots/sec, 
// 1/6.667 = 0.15s between, therefore...
// Due to excessive whining, shots/sec is increased to 7.5
// 1/7.5 = 0.13s between.
// Due to more testing, I have now set fireinterval up to 8.0
// 1/8.0 = 0.125s between
// And now, finally, I messed mini up totally, by increasing ROF by 50%, and reducing damage in half.
// 1/12.5 = 0.08s between
state NormalFire
{
	function Tick( float DeltaTime )
	{
		local Pawn P;

		P = Pawn(Owner);

		if (P == None)
			return;
	
		if (P.Weapon != Self)
			AmbientSound = None;

		FireInterval -= DeltaTime;
		while (FireInterval < 0.0)
		{
//			Log("FireInterval"@FireInterval@"Next"@NextFireInterval);
			FireInterval += NextFireInterval;
//			if (P.bAltFire == 0)
			GenerateBullet();
		}

		if	( bFiredShot && ((P.bFire==0) || bOutOfAmmo) ) 
			GoToState('FinishFire');
	}

	function AnimEnd()
	{
		if ( AmbientSound == None )
			AmbientSound = FireSound;
		if ( Affector != None )
			Affector.FireEffect();
	}

Begin:
}

// Original code did: Sleep(0.08)
// This would (depending on tickrate) get called on irregular intervals.
// According to a 20 tickrate server, this would result in about 10.000 shots/sec, 
// 1/10.000 = 0.10s between, therefore...
// Due to excessive whining, shots/sec increased to 11
// 1/11 = 0.091s between
// Due to more testing, I have now increased shots/sec to 12.5
// 1/12.5 = 0.08s (look in AnimEnd)
// And now, finally, I messed mini up totally, by increasing ROF by 50%, and reducing damage in half.
// 1/20 = 0.05s between
state AltFiring
{
	function Tick( float DeltaTime )
	{
		local Pawn P;

		P = Pawn(Owner);

		if (P == None)
			return;

		if (P.Weapon != Self)
			AmbientSound = None;

		FireInterval -= DeltaTime;
		while (FireInterval < 0.0)
		{
//			Log("FireInterval"@FireInterval@"Next"@NextFireInterval);
			FireInterval += NextFireInterval;
//			if (P.bFire == 0)
			GenerateBullet();
		}

		if	( bFiredShot && ((P.bAltFire==0) || bOutOfAmmo) ) 
			GoToState('FinishFire');
	}

	function AnimEnd()
	{
		if ( (AnimSequence != 'Shoot2') || !bAnimLoop )
		{	
			AmbientSound = AltFireSound;
			SoundVolume = 255*Pawn(Owner).SoundDampening;
			LoopAnim('Shoot2',1.9);
			NextFireInterval = 0.05;	// 20.0 shots/sec ..12.5 shots/sec
		}
		else if ( AmbientSound == None )
			AmbientSound = FireSound;
		if ( Affector != None )
			Affector.FireEffect();
	}
Begin:
}

State ClientDown
{
	simulated function AnimEnd()
	{
		local TournamentPlayer T;

		T = TournamentPlayer(Owner);
		if ( T != None )
		{
			if ( (T.ClientPending != None) 
				&& (T.ClientPending.Owner == Owner) )
			{
				T.Weapon = T.ClientPending;
				T.Weapon.GotoState('ClientActive');
				T.ClientPending = None;
				GotoState('');
			}
			else
			{
				T.NeedActivate();
			}
		}
	}

	simulated function BeginState();
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local int rndDam;

	if (Other == Level) 
		Spawn(class'UT_LightWallHitEffect',,, HitLocation+HitNormal, Rotator(HitNormal));
	else if ( (Other!=self) && (Other!=Owner) && (Other != None) ) 
	{
		if ( !Other.bIsPawn && !Other.IsA('Carcass') )
			spawn(class'UT_SpriteSmokePuff',,,HitLocation+HitNormal*9); 
		else
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);

		if ( Other.IsA('Bot') && (FRand() < 0.2) )
			Pawn(Other).WarnTarget(Pawn(Owner), 500, X);
		// Original code did, 9 + rand(6), which produced 9-14 damage/shot.
		// Also, UT increases all damage with 50% (*1.5), meaning original minigun did 13-21 damage/shot.
		// I feel this is too much, and have reduced it slightly.
		rndDam = 5 + Rand(3);
		// This gives 8-13 damage/shot, or 12-19.5 after multiplication.
		// Original avg damage = 13+21/2 = 17, this avg will be 12+19.5/2 = 15.25
		// Also any "push" (momentum transfer) is removed.
		Other.TakeDamage(rndDam, Pawn(Owner), HitLocation, vect(0,0,0), MyDamageType);
	}
}

function SetSwitchPriority(pawn Other)
{	// Make sure "old" priorities are kept.
	local int i;
	local name temp, carried;

	if ( PlayerPawn(Other) != None )
	{
		for ( i=0; i<ArrayCount(PlayerPawn(Other).WeaponPriority); i++)
			if ( IsA(PlayerPawn(Other).WeaponPriority[i]) )		// <- The fix...
			{
				AutoSwitchPriority = i;
				return;
			}
		// else, register this weapon
		carried = 'minigun2';
		for ( i=AutoSwitchPriority; i<ArrayCount(PlayerPawn(Other).WeaponPriority); i++ )
		{
			if ( PlayerPawn(Other).WeaponPriority[i] == '' )
			{
				PlayerPawn(Other).WeaponPriority[i] = carried;
				return;
			}
			else if ( i<ArrayCount(PlayerPawn(Other).WeaponPriority)-1 )
			{
				temp = PlayerPawn(Other).WeaponPriority[i];
				PlayerPawn(Other).WeaponPriority[i] = carried;
				carried = temp;
			}
		}
	}		
}

simulated function PlayIdleAnim()
{
	if ( Mesh != PickupViewMesh )
		PlayAnim('Still',1.0, 0.05);
}

function TweenDown()
{
	PlayAnim('Down', 100.0, 0.00);
}

function PlaySelect()
{
	PlayAnim('Select',100.0,0.0);
	Owner.PlaySound(SelectSound, SLOT_Misc, Pawn(Owner).SoundDampening);
}

simulated function Tick(float DeltaTime)
{
	if ((Region.Zone.bDestructive || Region.Zone.bKillZone || Region.Zone.DamagePerSec > 0) && Pawn(Owner) == None)
	{
		Destroy();
	}
}

defaultproperties {
	FireInterval=0.130
	NextFireInterval=0.08
	PickupMessage="You got a Minigun."
}
