//===================================================================
// Author: *Kr!D_o)
// Mutator: EnhancedUTv1b
//===================================================================
class UTMod expands Mutator;

var string Version;
var DeathMatchPlus DMP;
var Class<ServerInfo> ServerInfo;
var bool bInitialized;
var config bool bHitSounds;
var localized config bool bNoLockdown;

function PreBeginPlay()
{
	DMP = DeathMatchPlus(Level.Game);
	
	if (DMP == None)
		return;

	if (DMP.HUDType == Class'ChallengeDominationHUD')
		DMP.HUDType = Class'EnhancedDOMHUD';
	else if (DMP.HUDType == Class'ChallengeCTFHUD')
		DMP.HUDType = Class'EnhancedCTFHUD';
	else if (DMP.HUDType == Class'AssaultHUD')
		DMP.HUDType = Class'EnhancedASHUD';
	else if (DMP.HUDType == Class'ChallengeTeamHUD')
		DMP.HUDType = Class'EnhancedTDMHUD';
	else if (DMP.HUDType == Class'ChallengeHUD')
		DMP.HUDType = Class'EnhancedDMHUD';

	ServerInfo = Class<ChallengeHUD>(DMP.HUDType).Default.ServerInfoClass;
	
	if (!bInitialized)
	{
		bInitialized = True;	
		Spawn(class'Notify'); // Cleans up the bind fix junk =]P
		Log("Initialized EnhancedUTv1b - created by *Kr!D_o)");
	}

	Super.BeginPlay();
	if (Level.NetMode != NM_Client) { Level.Game.RegisterDamageMutator(Self); }
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
if (Level.NetMode != NM_Client) { 
	if ( Other.IsA('Inventory') )
	{
		bSuperRelevant = 1;
		if ( !Level.bStartup ) 
			if (Other.class==class'Botpack.enforcer' ) {
                           //ReplaceWith(Other, Version$".NW_Enforcer");
                           return False;
                           }
		if ( Level.bStartup )
		{ // Swaps the new weapons =]P
			if (Other.class==class'Botpack.SniperRifle' ) {
                           ReplaceWith(Other, Version$".NW_SniperRifle");
                           return False;
                           }
			if (Other.class==class'Botpack.UT_Eightball' ) {
                           ReplaceWith(Other, Version$".NW_EightBall");
                           return False;
                           }
			if (Other.class==class'Botpack.UT_FlakCannon' ) {
                           ReplaceWith(Other, Version$".NW_FlakCannon");
                           return False;
                           }
			if (Other.class==class'Botpack.minigun2' ) {
                           ReplaceWith(Other, Version$".NW_Minigun");
                           return False;
                           }
			if (Other.class==class'Botpack.ripper' ) {
                           ReplaceWith(Other, Version$".NW_BladeRipper");
                           return False;
                           }
			if (Other.class==class'Botpack.PulseGun' ) {
                           ReplaceWith(Other, Version$".NW_PulseGun");
                           return False;
                           }
			if (Other.class==class'Botpack.ShockRifle' ) {
                           ReplaceWith(Other, Version$".NW_ShockRifle");
                           return False;
                           }
			if (Other.class==class'Botpack.ut_biorifle' ) {
                           ReplaceWith(Other, Version$".NW_BioRifle");
                           return False;
                           }
			if (Other.class==class'Botpack.enforcer' ) {
                           ReplaceWith(Other, Version$".NW_Enforcer");
                           return False;
                           }
			if (Other.class==class'Botpack.ImpactHammer' ) {
                           ReplaceWith(Other, Version$".NW_ImpactHammer");
                           return False;
                           }
			if (Other.class==class'Botpack.Translocator' ) {
                           ReplaceWith(Other, Version$".NW_Translocator");
                           return False;
                           }
			// And now all other pick-up's =]P
			if (Other.class==class'Botpack.thighpads' ) {
                           ReplaceWith(Other, Version$".ThighPadz");
                           return False;
                           }
			if (Other.class==class'Botpack.armor2' ) {
                           ReplaceWith(Other, Version$".BodyArmor");
                           return False;
                           }
			if (Other.class==class'Botpack.ut_shieldbelt' ) {
                           ReplaceWith(Other, Version$".ShieldBelt");
                           return False;
                           }
			if (Other.class==class'Botpack.medbox' ) {
                           ReplaceWith(Other, Version$".HealthPack");
                           return False;
                           }
			if (Other.class==class'Botpack.healthvial' ) {
                           ReplaceWith(Other, Version$".HealthVialz");
                           return False;
                           }
			if (Other.class==class'Botpack.healthpack' ) {
                           ReplaceWith(Other, Version$".HealthKeg");
                           return False;
                           }
			if (Other.class==class'Botpack.udamage') {
                           ReplaceWith(Other, Version$".DamageAmplifier");
                           return False;
                           }
			if (Other.class==class'Botpack.ut_invisibility' ) {
                           ReplaceWith(Other, Version$".Invisibility");
                           return False;
                           }
			if (Other.class==class'Botpack.ut_jumpboots' ) {
                           ReplaceWith(Other, Version$".JumpBoots");
                           return False;
                           }
		}
	}

	bSuperRelevant = 0;
	return True;
   }
}

function bool HandlePickupQuery(Pawn Other, Inventory item, out byte bAllowPickup)
{
	local bool bValid;
	local int i;
	local Inventory belt, pads, armor;

	bValid = false;
	for (i = 0; i<4; i++)
	{	// This part makes sure that you cannot receive items unless you atually touch
		if (Other.Touching[i] == item)
			bValid=true;
	}
	if (!bValid)
	{
		bAllowPickup = 0;
		return true;
		//  Used to return false. It needs to return 0 & true to be considered.
		//	Level.Game.PickupQuery():
		//	if ( BaseMutator.HandlePickupQuery(Other, item, bAllowPickup) )
		//	return (bAllowPickup == 1);

	}

	if (item.IsA('UT_ShieldBelt'))
	{
		item.Default.Charge = 150;
	}
	else if (item.IsA('Armor2') || item.IsA('ThighPads'))
	{
		belt = Other.FindInventoryType(class'UT_ShieldBelt');
		if (belt != None)
		{
			belt.Default.Charge = 150;
			pads = Other.FindInventoryType(class'ThighPads');
			armor = Other.FindInventoryType(class'Armor2');

			// Only care if Belt+Pads are present
			if (item.IsA('Armor2') && pads != None)
				belt.Default.Charge = 150 - pads.charge;
			else if (item.IsA('ThighPads') && armor != None)
				belt.Default.Charge = 150 - armor.charge;
		}
	}

	return super.HandlePickupQuery(Other, item, bAllowPickup);
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	if ( (bHitSounds) && (Level.Game.bTeamGame) && (Victim.PlayerReplicationInfo.Team == InstigatedBy.PlayerReplicationInfo.Team) )
	{
                PlayerPawn(InstigatedBy).PlaySound(Sound'UnrealShare.StingerFire', SLOT_None, 255, True);
	}
	else if ( (bHitSounds) && InstigatedBy.IsA('PlayerPawn') && (Victim != InstigatedBy) )
	{
				PlayerPawn(InstigatedBy).PlaySound(Sound'UnrealShare.StingerFire', SLOT_None, 255, True);
	}

    if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType );
}

function WeapBindFix getclient(PlayerPawn P)
{
	Local WeapBindFix Client;
	foreach AllActors(class'WeapBindFix', Client)
	{		
		if (Client.Owner == P) { return Client; }
	}		
}

function ModifyPlayer (Pawn Player)
{
	GiveWeapon(Player, Version$".NW_Enforcer");
	if (NextMutator != None) { nextmutator.ModifyPlayer(Player); }	
}

function GiveWeapon(Pawn PlayerPawn, string aClassName )
{
	local class<Weapon> WeaponClass;
	local Weapon NewWeapon;

	WeaponClass = class<Weapon>(DynamicLoadObject(aClassName, class'Class'));

	if( PlayerPawn.FindInventoryType(WeaponClass) != None )
		return;
	newWeapon = Spawn(WeaponClass);
	if( newWeapon != None )
	{
		newWeapon.RespawnTime = 0.0;
		newWeapon.GiveTo(PlayerPawn);
		newWeapon.bHeldItem = true;
		newWeapon.GiveAmmo(PlayerPawn);
		newWeapon.SetSwitchPriority(PlayerPawn);
		newWeapon.WeaponSet(PlayerPawn);
		newWeapon.AmbientGlow = 0;
		if ( PlayerPawn.IsA('PlayerPawn') )
			newWeapon.SetHand(PlayerPawn(PlayerPawn).Handedness);
		else
			newWeapon.GotoState('Idle');
		PlayerPawn.Weapon.GotoState('DownWeapon');
		PlayerPawn.PendingWeapon = None;
		PlayerPawn.Weapon = newWeapon;
	}
}

defaultproperties {
    Version="EnhancedUTv1b"
	bHitSounds=True
	bNoLockdown=True
}
